/**
 *	@file	DialogKiller.h
 *	@brief	̃_CAOoȂ悤ɂ鏈.
 */
#pragma once


// for debug
#ifdef _DEBUG
	const bool _Mtl_DialogKiller_traceOn = false;
	#define dgkTRACE	if (_Mtl_DialogKiller_traceOn) ATLTRACE
#else
	#define dgkTRACE
#endif


class CDialogKiller2 {
public:

	static void KillDialog()
	{
		dgkTRACE( _T("KillDialog\n") );

		// I guess this is not so slow.
		MtlForEachTopLevelWindow( _T("#32770"), NULL, _Function_DialogFilter() );
		MtlForEachTopLevelWindow( _T("Internet Explorer_TridentDlgFrame"), NULL, _Function_TridentFrameDlgFilter() );
	}


private:
	struct _Function_DialogFilter {
		bool operator ()(HWND hWnd)
		{
			if ( MtlIsWindowCurrentProcess(hWnd) ) {
				CString 	strCaption = MtlGetWindowText(hWnd);
				if ( _Filter_ActiveXWarningDialog (hWnd, strCaption) )	return true;
				if ( _Filter_SecurityWarningDialog(hWnd, strCaption) )	return true;
				if ( _Filter_OfflineDialog(hWnd, strCaption) )			return true;
				if ( _Filter_ClientAttestationDialog(hWnd,strCaption) ) return true;
			}
			return true;
		}
	};


	struct _Function_TridentFrameDlgFilter {
		bool operator ()(HWND hWnd)
		{
			if ( MtlIsWindowCurrentProcess(hWnd) ) {
				CString strCaption = MtlGetWindowText(hWnd);
				_Filter_ScriptErrorTridentDlgFrame(hWnd, strCaption);
			}
			return true;
		}
	};


	static bool _Filter_ScriptErrorTridentDlgFrame(CWindow wnd, const CString &strCaption)
	{
		if ( (strCaption.Find( _T("XNvg") ) != -1 && strCaption.Find( _T("G[") ) != -1)
		   || (strCaption.Compare(_T("Internet Explorer XNvg G[")) == 0) )
		{
			// wnd.ModifyStyle(WS_VISIBLE, 0, SWP_NOACTIVATE);
			wnd.SendMessage(WM_CLOSE);
			// wnd.SendMessage(WM_KEYDOWN, VK_ESCAPE);
			return true;
		}

		return false;
	}


	static bool _Filter_OfflineDialog(CWindow wnd, const CString &strCaption)
	{
		if (strCaption.Find( _T("ItCł") ) != -1) {
			wnd.SendMessage( WM_COMMAND, MAKEWPARAM(IDCANCEL, 0) );
			wnd.SendMessage( WM_COMMAND, MAKEWPARAM(IDOK, 0) );
			// wnd.SendMessage(WM_KEYDOWN, VK_ESCAPE);
			return true;
		}

		return false;
	}


	static bool _Filter_ClientAttestationDialog(CWindow wnd, const CString &strCaption)
	{
		if (strCaption.Find( _T("NCAgF") ) != -1) {
			wnd.SendMessage(WM_CLOSE);
			return true;
		}

		return false;
	}


	static bool _Filter_SecurityWarningDialog(CWindow wnd, const CString &strCaption)
	{
		if ( strCaption != _T("ZLeB") )
			return false;

		CWindow 	wndInner = wnd.GetDlgItem(0x0000FFFF);
		if (wndInner.m_hWnd == NULL)
			return false;

		CString strOneStaticText = MtlGetWindowText(wndInner.m_hWnd);

		if (strOneStaticText.Find( _T("̃y[Wɂ") ) != -1 && strOneStaticText.Find( _T("ی") ) != -1) {
			wnd.SendMessage( WM_COMMAND, MAKEWPARAM(IDCANCEL, 0) );
			wnd.SendMessage( WM_COMMAND, MAKEWPARAM(IDOK	, 0) );
			// wnd.SendMessage(WM_KEYDOWN, VK_ESCAPE);
			return true;
		}

		return false;
	}


	static bool _Filter_ActiveXWarningDialog(CWindow wnd, const CString &strCaption)
	{
		if (  strCaption != _T("Microsoft Internet Explorer")			// IE6܂
		   && strCaption != _T("Internet Explorer - Security Warning")	// IE7A
		   && strCaption != _T("Internet Explorer") 					// Xŕ񍐂
		   && strCaption != _T("Windows Internet Explorer") 			//+++ IE7΍. by 2chX"unDonut Part16" 149.
		){
			return false;
		}

		CWindow 	wndInner = wnd.GetDlgItem(0x0000FFFF);
		if (wndInner.m_hWnd == NULL)
			return false;

		CString strOneStaticText = MtlGetWindowText(wndInner.m_hWnd);

		if (strOneStaticText.Find( _T("ActiveX") ) != -1 && strOneStaticText.Find( _T("S") ) != -1) {
			wnd.SendMessage( WM_COMMAND, MAKEWPARAM(IDCANCEL, 0) );
			wnd.SendMessage( WM_COMMAND, MAKEWPARAM(IDOK, 0) );
			// wnd.SendMessage(WM_KEYDOWN, VK_ESCAPE);
			return true;
		} else if (strOneStaticText.Find( _T("ActiveX") ) != -1 && strOneStaticText.Find( _T("s") ) != -1) {
			wnd.SendMessage( WM_COMMAND, MAKEWPARAM(IDCANCEL, 0) );
			wnd.SendMessage( WM_COMMAND, MAKEWPARAM(IDOK, 0) );
			// wnd.SendMessage(WM_KEYDOWN, VK_ESCAPE);
			return true;
		} else if (strOneStaticText.Find( _T("J܂") ) != -1) {
			wnd.SendMessage( WM_COMMAND, MAKEWPARAM(IDCANCEL, 0) );
			wnd.SendMessage( WM_COMMAND, MAKEWPARAM(IDOK, 0) );
			// wnd.SendMessage(WM_KEYDOWN, VK_ESCAPE);
			return true;
		}

		return false;
	}
};

