/**
 *	@file	Misc.h
 *	@biref	Gȃ[`Q
 */
#pragma once

#include <stdarg.h>


namespace Misc {


inline bool IsExistFile(LPCTSTR fname)
{
	return ::GetFileAttributes(fname) != 0xFFFFFFFF;
}


/// .exêfBNg̃tpXԂ. Ō'\\'܂.
//   JgfBNg̎擾.
inline const CString GetCurDirectory()
{
	TCHAR dir[MAX_PATH+2];
	dir[0] = 0;
	::GetCurrentDirectory(MAX_PATH, dir);
	return CString(dir);
}


//+++
inline int SetCurDirectory(const CString& strDir)
{
	return ::SetCurrentDirectory(LPCTSTR(strDir));
}



//+++ t@CpXAfBNg擾. Ō'\\'͊܂܂Ȃ.
inline const CString	GetDirName(const CString& strFileName)
{
	int 	n	= strFileName.ReverseFind( _T('\\') );
	if (n < 0)
		return _T(".");	//strFileName;
	return	strFileName.Left(n);
}


///+++ exe(dll)̃tpXԂ.
CString 	GetExeFileName();


///+++ exe(dll)̂tH_Ԃ. Ō'\\'tȂ
inline CString GetExeDirName()
{
	CString str = GetExeFileName();
	int 	n	= str.ReverseFind( _T('\\') );
	return	str.Left(n);
}


//+++ t@CpXAt@C擾
inline const CString	GetFileBaseName(const CString& strFileName)
{
	int 	n	= strFileName.ReverseFind( _T('\\') );
	if (n < 0)
		return strFileName;
	return	strFileName.Mid(n + 1);
}


///+++ t@C̊gq̎擾.  ʂ̕ɂ'.'͊܂܂Ȃ.
inline const CString	GetFileExt(const CString& strFileName)
{
	const CString strBaseName = GetFileBaseName(strFileName);
	int 	n	= strBaseName.ReverseFind( _T('.') );
	if (n < 0)
		return CString();
	return strBaseName.Mid(n + 1);
}


///+++ gq̃t@C̎擾.  ʂ̕ɂ'.'͊܂܂Ȃ.
inline const CString	GetFileNameNoExt(const CString& strFileName)
{
	const CString strBaseName = GetFileBaseName(strFileName);
	int 	n	= strBaseName.ReverseFind( _T('.') );
	if (n < 0)
		return strFileName;

	int 	nd	= strFileName.ReverseFind( _T('\\') );
	if (nd >= 0)
		return strFileName.Left(nd + 1) + strBaseName.Left(n);
	return strBaseName.Left(n);
}



inline const CString StrFmt(const char* fmt, ...)
{
	va_list app;
	va_start(app, fmt);
	CString 	str;
	str.FormatV(fmt, app);
	va_end(app);
	return str;
}



}	// namespace Misc
